' Import Microsoft SqlClient
Imports System.Data.SqlClient

Partial Class Register
    Inherits System.Web.UI.Page

    Protected Sub btnRegister_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnRegister.Click

        ' Takes the data from the form at "Insert-into-mssql.aspx" when the button is clicked and then Inserts 
        ' this data to the table "Users" in the specified fields.

        ' Set the SqlEx label to a empty string.
        SqlEx.Text = String.Empty

        Try
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
            Dim sql As String = "INSERT INTO Users (Username, Password, Company, OrgNumber, Contact, Attention, Adress, PostalCode, City, Country, RegisterDate, ExpireDate, Admin) VALUES (@Username, @Password, @Company, @OrgNumber, @Contact, @Attention, @Adress, @PostalCode, @City, @Country, @RegisterDate, @ExpireDate, @Admin)"

            ' The Using block is used to call dispose (close) automatically even if there are an exception. A new
            ' SqlConnection and a new SqlCommand are created.
            Using cn As New SqlConnection(ConnString), _
                  cmd As New SqlCommand(sql, cn)

                ' Add parameters for the WHERE clause, parameters are used to make it hard for hackers to modify
                ' the sql statement.
                cmd.Parameters.Add("@Username", Data.SqlDbType.VarChar, 80).Value = txtUserName.Text
                cmd.Parameters.Add("@Password", Data.SqlDbType.VarChar, 40).Value = txtPassword.Text
                cmd.Parameters.Add("@Company", Data.SqlDbType.VarChar, 50).Value = txtCompanyName.Text
                cmd.Parameters.Add("@OrgNumber", Data.SqlDbType.VarChar, 15).Value = txtOrganisationNumber.Text
                cmd.Parameters.Add("@Contact", Data.SqlDbType.VarChar, 50).Value = txtContact.Text
                cmd.Parameters.Add("@Attention", Data.SqlDbType.VarChar, 50).Value = txtAttention.Text
                cmd.Parameters.Add("@Adress", Data.SqlDbType.VarChar, 50).Value = txtAdress.Text
                cmd.Parameters.Add("@PostalCode", Data.SqlDbType.VarChar, 10).Value = txtPostalCode.Text
                cmd.Parameters.Add("@City", Data.SqlDbType.VarChar, 50).Value = txtCity.Text
                cmd.Parameters.Add("@Country", Data.SqlDbType.VarChar, 50).Value = txtCountry.Text
                cmd.Parameters.Add("@RegisterDate", Data.SqlDbType.SmallDateTime).Value = DateTime.Now.ToString()
                cmd.Parameters.Add("@ExpireDate", Data.SqlDbType.SmallDateTime).Value = DateTime.Now.AddYears(1).ToString()
                cmd.Parameters.Add("@Admin", Data.SqlDbType.Bit).Value = 0

                ' Open the Sql connection, will be closed in the End Using statement.
                cn.Open()

                ' Execute the INSERT statement.
                cmd.ExecuteNonQuery()

                ' Set visibility for panels.
                CurrentPanel.Visible = False
                ThankYouPanel.Visible = True

            End Using

        Catch SqlExc As SqlException

            ' Catch a SqlException
            Select Case SqlExc.Number
                Case 2601
                    SqlEx.Text = "* Given E-mail already exists"
                Case Else
                    Response.Write(SqlExc.Message)
            End Select

        Catch Ex As Exception

            ' Catch a general exception that is not a SqlException
            Response.Write(Ex.Message)

        End Try

    End Sub
End Class
